=== debian/changelog ===
raptor2 (2.0.16-6) unstable; urgency=medium

  * QA upload.
  * Integer Underflow in raptor_uri_normalize_path() (CVE-2024-57823)
    (Closes: #1067896)
  * Heap read buffer overflow in ntriples bnode (CVE-2024-57822)
    (Closes: #1067896)
  * Tests for Github issue 70

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 29 Mar 2025 15:33:08 +0100

raptor2 (2.0.16-5) unstable; urgency=medium

  * QA upload.
  * Make OpenSSL the primary curl backend.
  * Update Standards-Version to 4.7.1, no changes needed.
  * Add upstream signing key and check the signature.

 -- Simon Quigley <tsimonq2@debian.org>  Sat, 22 Feb 2025 17:04:28 -0600

raptor2 (2.0.16-4) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with libxml2 2.11.  (Closes: #1073350)
  * Switch B-D from transitional pkg-config to pkgconf.
  * Fix running tests in parallel.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 29 Jun 2024 10:43:44 +0200

raptor2 (2.0.16-3) unstable; urgency=medium

  * QA upload.
  * Backport upstream commit 3b7ed0e67f919e49ea8b1f5387c14b762f446b45 to fix
    the selection of the used sort_r() on Hurd; patch
    upstream_Fix-sort_r-selection-on-GNU-Hurd.patch.

 -- Pino Toscano <pino@debian.org>  Sat, 08 Jul 2023 06:17:35 +0200

raptor2 (2.0.16-2) unstable; urgency=medium

  * QA upload.
  * Move from experimental to unstable.
  * Add libcurl-ssl-dev as alternative to libcurl4-gnutls-dev. LP: #1899809
  * Add libicu-dev as BD.
  * Enable all tests but do not run them in parallel.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Mon, 03 Jul 2023 08:56:32 +0200

raptor2 (2.0.16-1) experimental; urgency=medium

  * QA upload.
  * New upstream version.
    + Drop patches (included upstream):
      - Calculate-max-nspace-declarations-correctly-for-XML-.patch
      - CVE-2020-25713-raptor2-malformed-input-file-can-lead.patch
      - configure.ac-Allow-use-of-pkg-config-to-detect-the-libxsl.patch
      - configure.ac-libxml2.patch
    + Drop unused lintian overrides.
    + Update symbol file.
    + Update copyright info.
  * Bump Standards-Version, no changes.
  * Run wrap-and-sort -ast.
  * Create repo on salsa and add Vcs-* fields to debian/control.
  * Install gtk-doc reference manual to native path
    (/usr/share/gtk-doc/html/raptor2) instead of
    /usr/share/doc/libraptor2-dev/raptor2/.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 06 May 2023 11:29:05 +0200
