=== debian/watch ===
version=4
opts=pgpmode=auto \
https://download.librdf.org/source/ raptor2-([\d+\.]+|\d+)\.tar\.gz
